import { resolveComponent as s, createElementBlock as p, openBlock as y, Fragment as b, createVNode as c, withDirectives as g, mergeProps as V, createSlots as S, withCtx as v, createElementVNode as _, toDisplayString as f, vShow as w } from "vue";
function j(e) {
  return e && e.__esModule && Object.prototype.hasOwnProperty.call(e, "default") ? e.default : e;
}
var l, d;
function k() {
  if (d) return l;
  d = 1;
  var e = Object.prototype.hasOwnProperty, n = Object.prototype.toString;
  function t(r) {
    if (r == null) return !0;
    if (typeof r == "boolean") return !1;
    if (typeof r == "number") return r === 0;
    if (typeof r == "string" || typeof r == "function" || Array.isArray(r)) return r.length === 0;
    if (r instanceof Error) return r.message === "";
    if (r.toString == n)
      switch (r.toString()) {
        // Maps, Sets, Files and Errors...
        case "[object File]":
        case "[object Map]":
        case "[object Set]":
          return r.size === 0;
        // Plain objects...
        case "[object Object]": {
          for (var o in r)
            if (e.call(r, o)) return !1;
          return !0;
        }
      }
    return !1;
  }
  return l = t, l;
}
var C = k();
const a = /* @__PURE__ */ j(C), x = (e, n) => {
  const t = e.__vccOpts || e;
  for (const [r, o] of n)
    t[r] = o;
  return t;
}, D = {
  name: "v-autocomplete-extended",
  props: {
    rules: {
      type: Array,
      default: () => []
    },
    modelValue: {
      type: String
    },
    variant: {
      type: String
    },
    items: {
      type: Array,
      default: () => []
    },
    other: {
      type: String
    },
    position: {
      type: String,
      default: "end",
      validator: (e) => ["start", "end"].includes(e)
    },
    noDataText: {
      type: String,
      default: "Clic para especificar"
    },
    otherLabel: {
      type: String,
      default: "Otra opción (especifique)"
    }
  },
  mounted() {
    this.selectedValue = this.modelValue;
  },
  data() {
    return {
      selectedValue: null,
      value: "",
      showInput: !1
    };
  },
  methods: {
    onNoDataClick() {
      this.showInput = !0, this.$refs.autocompleteMenu.menu = !1, this.selectedValue = this.other, this.$emit("update:modelValue", this.other), this.$nextTick(() => {
        const e = this.$refs.autocompleteMenu.$el.querySelector("input");
        e && e.blur();
      });
    }
  },
  watch: {
    modelValue(e, n) {
      n == null && e != null && a(this.other) && (this.selectedValue = e);
    },
    async selectedValue(e) {
      a(e) || (!a(this.other) && e == this.other ? (this.value = "", this.showInput = !0) : (this.value = e, this.showInput = !1));
    },
    value(e) {
      this.$emit("update:modelValue", e);
    }
  }
};
function E(e, n, t, r, o, u) {
  const m = s("v-autocomplete"), h = s("v-text-field");
  return y(), p(b, null, [
    c(m, V({
      rules: t.rules,
      modelValue: o.selectedValue,
      "onUpdate:modelValue": n[1] || (n[1] = (i) => o.selectedValue = i),
      label: e.$attrs.label,
      ref: "autocompleteMenu",
      items: t.other ? t.position === "start" ? [t.other, ...t.items] : [...t.items, t.other] : t.items,
      variant: t.variant
    }, e.$attrs, { autocomplete: "off" }), S({ _: 2 }, [
      t.other ? {
        name: "no-data",
        fn: v(() => [
          _("span", {
            text: "",
            onClick: n[0] || (n[0] = (...i) => u.onNoDataClick && u.onNoDataClick(...i)),
            class: "pl-4 py-2 cursor-pointer"
          }, f(t.noDataText) + " " + f(t.other.toLowerCase()), 1)
        ]),
        key: "0"
      } : void 0
    ]), 1040, ["rules", "modelValue", "label", "items", "variant"]),
    g(c(h, {
      rules: t.rules,
      modelValue: o.value,
      "onUpdate:modelValue": n[2] || (n[2] = (i) => o.value = i),
      variant: t.variant,
      label: t.otherLabel,
      autocomplete: "off"
    }, null, 8, ["rules", "modelValue", "variant", "label"]), [
      [w, o.showInput]
    ])
  ], 64);
}
const I = /* @__PURE__ */ x(D, [["render", E]]);
export {
  I as default
};
